package com.winhc.returnmoney.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @description ReturnMoneyChangeRecord实体对象
 * @author Generator
 * @date 2022-04-07
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("RETURN_MONEY_CHANGE_RECORD")
@ApiModel(value="ReturnMoneyChangeRecord实体对象", description="回款宝账款收付款记录表")
public class ReturnMoneyChangeRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "ID", type = IdType.AUTO)
    private Long id;

    @ApiModelProperty(value = "账本id")
    @TableField("RETURN_MONEY_BOOK_ID")
    private Long returnMoneyBookId;

    @ApiModelProperty(value = "账款id")
    @TableField("RETURN_MONEY_BILL_ID")
    private Long returnMoneyBillId;

    @ApiModelProperty(value = "收回金额/已付金额")
    @TableField("RECEIPT_MONEY")
    private BigDecimal receiptMoney;

    @ApiModelProperty(value = "收回前金额/应付前总金额")
    @TableField("PRE_MONEY")
    private BigDecimal preMoney;

    @ApiModelProperty(value = "操作人id")
    @TableField("OPER_USER_ID")
    private Long operUserId;

    @ApiModelProperty(value = "操作人name")
    @TableField("OPER_USER_NAME")
    private Long operUserName;

    @ApiModelProperty(value = "备注")
    @TableField("REMARK")
    private String remark;

    @ApiModelProperty(value = "附件url，逗号分隔")
    @TableField("FILE_URL")
    private String fileUrl;

    @ApiModelProperty(value = "是否删除，1删除。0否")
    @TableField("DELETED")
    private Integer deleted;

    @TableField("TIME_CREATED")
    private LocalDateTime timeCreated;

    @TableField("TIME_MODIFIED")
    private LocalDateTime timeModified;


}
