package com.winhc.returnmoney.service;

import com.winhc.returnmoney.entity.ReturnMoneyBill;
import com.baomidou.mybatisplus.extension.service.IService;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyBillDTO;
import com.winhc.returnmoney.model.vo.ReturnMoneyBillVO;
import java.util.List;


/**
 * @description ReturnMoneyBill 接口类
 * @author Generator
 * @date 2022-04-07
 */
public interface ReturnMoneyBillService extends IService<ReturnMoneyBill> {

    /**
    * add ReturnMoneyBill
    * @param dto data transfer object
    */
    void add(ReturnMoneyBillDTO dto);

    /**
    * update ReturnMoneyBill
    * @param id key
    * @param dto data transfer object
    */
    void update(Long id, ReturnMoneyBillDTO dto);

    /**
    * delete ReturnMoneyBill
    * @param id key
    */
    void delete(Long id);

    /**
    * find ReturnMoneyBill
    * @param id key
    * @return ReturnMoneyBill
    */
    ReturnMoneyBillVO find(Long id);

    /**
    * find ReturnMoneyBill list
    * @param dto data transfer object
    * @return list of ReturnMoneyBill
    */
    List<ReturnMoneyBillVO> find(ReturnMoneyBillDTO dto);

     /**
     * find ReturnMoneyBill page
     * @param dto data transfer object
     * @param pageNum page number
     * @param pageSize page size
     * @return page of ReturnMoneyBill
     */
     VOPage<ReturnMoneyBillVO> find(ReturnMoneyBillDTO dto, Integer pageNum, Integer pageSize);
}
