package com.winhc.returnmoney.service;

import com.winhc.returnmoney.entity.ReturnMoneyBook;
import com.baomidou.mybatisplus.extension.service.IService;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyBookDTO;
import com.winhc.returnmoney.model.vo.ReturnMoneyBookVO;
import java.util.List;


/**
 * @description ReturnMoneyBook 接口类
 * @author Generator
 * @date 2022-04-07
 */
public interface ReturnMoneyBookService extends IService<ReturnMoneyBook> {

    /**
    * add ReturnMoneyBook
    * @param dto data transfer object
    */
    void add(ReturnMoneyBookDTO dto);

    /**
    * update ReturnMoneyBook
    * @param id key
    * @param dto data transfer object
    */
    void update(Long id, ReturnMoneyBookDTO dto);

    /**
    * delete ReturnMoneyBook
    * @param id key
    */
    void delete(Long id);

    /**
    * find ReturnMoneyBook
    * @param id key
    * @return ReturnMoneyBook
    */
    ReturnMoneyBookVO find(Long id);

    /**
    * find ReturnMoneyBook list
    * @param dto data transfer object
    * @return list of ReturnMoneyBook
    */
    List<ReturnMoneyBookVO> find(ReturnMoneyBookDTO dto);

     /**
     * find ReturnMoneyBook page
     * @param dto data transfer object
     * @param pageNum page number
     * @param pageSize page size
     * @return page of ReturnMoneyBook
     */
     VOPage<ReturnMoneyBookVO> find(ReturnMoneyBookDTO dto, Integer pageNum, Integer pageSize);
}
