package com.winhc.returnmoney.service;

import com.winhc.returnmoney.entity.ReturnMoneyCustomer;
import com.baomidou.mybatisplus.extension.service.IService;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyCustomerDTO;
import com.winhc.returnmoney.model.vo.ReturnMoneyCustomerVO;
import java.util.List;


/**
 * @description ReturnMoneyCustomer 接口类
 * @author Generator
 * @date 2022-04-07
 */
public interface ReturnMoneyCustomerService extends IService<ReturnMoneyCustomer> {

    /**
    * add ReturnMoneyCustomer
    * @param dto data transfer object
    */
    void add(ReturnMoneyCustomerDTO dto);

    /**
    * update ReturnMoneyCustomer
    * @param custId key
    * @param dto data transfer object
    */
    void update(Long custId, ReturnMoneyCustomerDTO dto);

    /**
    * delete ReturnMoneyCustomer
    * @param custId key
    */
    void delete(Long custId);

    /**
    * find ReturnMoneyCustomer
    * @param custId key
    * @return ReturnMoneyCustomer
    */
    ReturnMoneyCustomerVO find(Long custId);

    /**
    * find ReturnMoneyCustomer list
    * @param dto data transfer object
    * @return list of ReturnMoneyCustomer
    */
    List<ReturnMoneyCustomerVO> find(ReturnMoneyCustomerDTO dto);

     /**
     * find ReturnMoneyCustomer page
     * @param dto data transfer object
     * @param pageNum page number
     * @param pageSize page size
     * @return page of ReturnMoneyCustomer
     */
     VOPage<ReturnMoneyCustomerVO> find(ReturnMoneyCustomerDTO dto, Integer pageNum, Integer pageSize);
}
