package com.winhc.returnmoney.service.impl;

import com.winhc.returnmoney.entity.ReturnMoneyBill;
import com.winhc.returnmoney.repository.ReturnMoneyBillMapper;
import com.winhc.returnmoney.service.ReturnMoneyBillService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyBillDTO;
import com.winhc.returnmoney.model.cvt.ReturnMoneyBillConvert;
import com.winhc.returnmoney.model.vo.ReturnMoneyBillVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description ReturnMoneyBill 接口实现类
 * @author Generator
 * @date 2022-04-07
 */
@Service
public class ReturnMoneyBillServiceImpl extends ServiceImpl<ReturnMoneyBillMapper, ReturnMoneyBill> implements ReturnMoneyBillService {

    @Override
    public void add(ReturnMoneyBillDTO dto) {
        save(ReturnMoneyBillConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long id, ReturnMoneyBillDTO dto) {
        update(ReturnMoneyBillConvert.DTOToEntity(dto),new UpdateWrapper<ReturnMoneyBill>().lambda().eq(ReturnMoneyBill::getId,id));
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

    @Override
    public ReturnMoneyBillVO find(Long id) {
        return ReturnMoneyBillConvert.EntityToVO(getById(id));
    }

    @Override
    public List<ReturnMoneyBillVO> find(ReturnMoneyBillDTO dto) {
        return list(new QueryWrapper<>(ReturnMoneyBillConvert.DTOToEntity(dto))).stream().map(ReturnMoneyBillConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<ReturnMoneyBillVO> find(ReturnMoneyBillDTO dto, Integer pageNum, Integer pageSize) {
         IPage<ReturnMoneyBill> pageReturnMoneyBill = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(ReturnMoneyBillConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageReturnMoneyBill.getTotal(), pageReturnMoneyBill.getRecords().stream()
                 .map(ReturnMoneyBillConvert::EntityToVO).collect(Collectors.toList()));
    }
}
