package com.winhc.returnmoney.service.impl;

import com.winhc.returnmoney.entity.ReturnMoneyBook;
import com.winhc.returnmoney.repository.ReturnMoneyBookMapper;
import com.winhc.returnmoney.service.ReturnMoneyBookService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyBookDTO;
import com.winhc.returnmoney.model.cvt.ReturnMoneyBookConvert;
import com.winhc.returnmoney.model.vo.ReturnMoneyBookVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description ReturnMoneyBook 接口实现类
 * @author Generator
 * @date 2022-04-07
 */
@Service
public class ReturnMoneyBookServiceImpl extends ServiceImpl<ReturnMoneyBookMapper, ReturnMoneyBook> implements ReturnMoneyBookService {

    @Override
    public void add(ReturnMoneyBookDTO dto) {
        save(ReturnMoneyBookConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long id, ReturnMoneyBookDTO dto) {
        update(ReturnMoneyBookConvert.DTOToEntity(dto),new UpdateWrapper<ReturnMoneyBook>().lambda().eq(ReturnMoneyBook::getId,id));
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

    @Override
    public ReturnMoneyBookVO find(Long id) {
        return ReturnMoneyBookConvert.EntityToVO(getById(id));
    }

    @Override
    public List<ReturnMoneyBookVO> find(ReturnMoneyBookDTO dto) {
        return list(new QueryWrapper<>(ReturnMoneyBookConvert.DTOToEntity(dto))).stream().map(ReturnMoneyBookConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<ReturnMoneyBookVO> find(ReturnMoneyBookDTO dto, Integer pageNum, Integer pageSize) {
         IPage<ReturnMoneyBook> pageReturnMoneyBook = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(ReturnMoneyBookConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageReturnMoneyBook.getTotal(), pageReturnMoneyBook.getRecords().stream()
                 .map(ReturnMoneyBookConvert::EntityToVO).collect(Collectors.toList()));
    }
}
