package com.winhc.returnmoney.service.impl;

import com.winhc.returnmoney.entity.ReturnMoneyChangeRecord;
import com.winhc.returnmoney.repository.ReturnMoneyChangeRecordMapper;
import com.winhc.returnmoney.service.ReturnMoneyChangeRecordService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyChangeRecordDTO;
import com.winhc.returnmoney.model.cvt.ReturnMoneyChangeRecordConvert;
import com.winhc.returnmoney.model.vo.ReturnMoneyChangeRecordVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description ReturnMoneyChangeRecord 接口实现类
 * @author Generator
 * @date 2022-04-07
 */
@Service
public class ReturnMoneyChangeRecordServiceImpl extends ServiceImpl<ReturnMoneyChangeRecordMapper, ReturnMoneyChangeRecord> implements ReturnMoneyChangeRecordService {

    @Override
    public void add(ReturnMoneyChangeRecordDTO dto) {
        save(ReturnMoneyChangeRecordConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long id, ReturnMoneyChangeRecordDTO dto) {
        update(ReturnMoneyChangeRecordConvert.DTOToEntity(dto),new UpdateWrapper<ReturnMoneyChangeRecord>().lambda().eq(ReturnMoneyChangeRecord::getId,id));
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

    @Override
    public ReturnMoneyChangeRecordVO find(Long id) {
        return ReturnMoneyChangeRecordConvert.EntityToVO(getById(id));
    }

    @Override
    public List<ReturnMoneyChangeRecordVO> find(ReturnMoneyChangeRecordDTO dto) {
        return list(new QueryWrapper<>(ReturnMoneyChangeRecordConvert.DTOToEntity(dto))).stream().map(ReturnMoneyChangeRecordConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<ReturnMoneyChangeRecordVO> find(ReturnMoneyChangeRecordDTO dto, Integer pageNum, Integer pageSize) {
         IPage<ReturnMoneyChangeRecord> pageReturnMoneyChangeRecord = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(ReturnMoneyChangeRecordConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageReturnMoneyChangeRecord.getTotal(), pageReturnMoneyChangeRecord.getRecords().stream()
                 .map(ReturnMoneyChangeRecordConvert::EntityToVO).collect(Collectors.toList()));
    }
}
