package com.winhc.returnmoney.service.impl;

import com.winhc.returnmoney.entity.ReturnMoneyCustomer;
import com.winhc.returnmoney.repository.ReturnMoneyCustomerMapper;
import com.winhc.returnmoney.service.ReturnMoneyCustomerService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyCustomerDTO;
import com.winhc.returnmoney.model.cvt.ReturnMoneyCustomerConvert;
import com.winhc.returnmoney.model.vo.ReturnMoneyCustomerVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description ReturnMoneyCustomer 接口实现类
 * @author Generator
 * @date 2022-04-07
 */
@Service
public class ReturnMoneyCustomerServiceImpl extends ServiceImpl<ReturnMoneyCustomerMapper, ReturnMoneyCustomer> implements ReturnMoneyCustomerService {

    @Override
    public void add(ReturnMoneyCustomerDTO dto) {
        save(ReturnMoneyCustomerConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long custId, ReturnMoneyCustomerDTO dto) {
        update(ReturnMoneyCustomerConvert.DTOToEntity(dto),new UpdateWrapper<ReturnMoneyCustomer>().lambda().eq(ReturnMoneyCustomer::getCustId,custId));
    }

    @Override
    public void delete(Long custId) {
        removeById(custId);
    }

    @Override
    public ReturnMoneyCustomerVO find(Long custId) {
        return ReturnMoneyCustomerConvert.EntityToVO(getById(custId));
    }

    @Override
    public List<ReturnMoneyCustomerVO> find(ReturnMoneyCustomerDTO dto) {
        return list(new QueryWrapper<>(ReturnMoneyCustomerConvert.DTOToEntity(dto))).stream().map(ReturnMoneyCustomerConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<ReturnMoneyCustomerVO> find(ReturnMoneyCustomerDTO dto, Integer pageNum, Integer pageSize) {
         IPage<ReturnMoneyCustomer> pageReturnMoneyCustomer = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(ReturnMoneyCustomerConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageReturnMoneyCustomer.getTotal(), pageReturnMoneyCustomer.getRecords().stream()
                 .map(ReturnMoneyCustomerConvert::EntityToVO).collect(Collectors.toList()));
    }
}
