package com.winhc.returnmoney.service.impl;

import com.winhc.returnmoney.entity.ReturnMoneyLink;
import com.winhc.returnmoney.repository.ReturnMoneyLinkMapper;
import com.winhc.returnmoney.service.ReturnMoneyLinkService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.returnmoney.model.dto.ReturnMoneyLinkDTO;
import com.winhc.returnmoney.model.cvt.ReturnMoneyLinkConvert;
import com.winhc.returnmoney.model.vo.ReturnMoneyLinkVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description ReturnMoneyLink 接口实现类
 * @author Generator
 * @date 2022-04-07
 */
@Service
public class ReturnMoneyLinkServiceImpl extends ServiceImpl<ReturnMoneyLinkMapper, ReturnMoneyLink> implements ReturnMoneyLinkService {

    @Override
    public void add(ReturnMoneyLinkDTO dto) {
        save(ReturnMoneyLinkConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long id, ReturnMoneyLinkDTO dto) {
        update(ReturnMoneyLinkConvert.DTOToEntity(dto),new UpdateWrapper<ReturnMoneyLink>().lambda().eq(ReturnMoneyLink::getId,id));
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

    @Override
    public ReturnMoneyLinkVO find(Long id) {
        return ReturnMoneyLinkConvert.EntityToVO(getById(id));
    }

    @Override
    public List<ReturnMoneyLinkVO> find(ReturnMoneyLinkDTO dto) {
        return list(new QueryWrapper<>(ReturnMoneyLinkConvert.DTOToEntity(dto))).stream().map(ReturnMoneyLinkConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<ReturnMoneyLinkVO> find(ReturnMoneyLinkDTO dto, Integer pageNum, Integer pageSize) {
         IPage<ReturnMoneyLink> pageReturnMoneyLink = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(ReturnMoneyLinkConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageReturnMoneyLink.getTotal(), pageReturnMoneyLink.getRecords().stream()
                 .map(ReturnMoneyLinkConvert::EntityToVO).collect(Collectors.toList()));
    }
}
